package com.nisum.javaSparkExample;

import com.nisum.javaSparkExample.model.Customers;
import org.apache.spark.sql.*;

import java.util.Arrays;
import java.util.List;

public class JavaSparkExampleApplication {

	public static void main(String[] args)
	{
		SparkSession sparkSession=SparkSession.builder()
				.master("local[*]")
				.appName("java spark example")
				//.config("spark.ui.enabled",true)
				.config("spark.sql.shuffle.partitions",2)
				.getOrCreate();
		List<Customers> customers = Arrays.asList(
				new Customers(01,"sarika","female",1000),
				new Customers(02,"sony","female",2000)

		);

		Dataset<Row> df = sparkSession.createDataFrame(customers,Customers.class);
		df.show(false);

		Dataset<Customers> mongoData = sparkSession.read()
				.format("mongo")
				.option("uri", "mongodb://localhost:27017/mydb.customers")
				.load().as(Encoders.bean(Customers.class));

		// Show data from MongoDB
		System.out.println("Data from MongoDB:");
		mongoData.show(false);



		Dataset df1 = df.filter(functions.col("id")
				.isNotNull())
				.select("name","gender");
		df1.show(false);
		df1.write().mode(SaveMode.Overwrite)
				.format("csv")
				.option("header",true)
				.save("D:/spark/customers.csv");


	}

}
